
import com.domain.Teacher;
import com.mapper.TeacherMapper;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import java.io.IOException;
import java.io.InputStream;
import java.util.List;

public class TestTeacherMapper {
    InputStream is=null;
    SqlSession session=null;
    TeacherMapper mapper=null;
    @Before
    public void before() throws IOException {
        // （1）读取核心配置文件
        is = Resources.getResourceAsStream("SqlMapConfig.xml");
        // （2）创建SqlSessionFactoryBuilder对象
        SqlSessionFactoryBuilder builder = new SqlSessionFactoryBuilder();
        // （3）SqlSessionFactoryBuilder对象获取SqlSessionFactory对象
        SqlSessionFactory factory = builder.build(is);
        // （4）SqlSessionFactory对象获取SqlSession对象
        session = factory.openSession();
        // （5）SqlSession对象获取代理对象，可以直接操纵数据库
        mapper = session. getMapper(TeacherMapper.class);
    }
    @After
    public void after() throws IOException {
        this.session.close();
        this.is.close();
    }
    @Test
    public void testFindAll(){
        List<Teacher> list = mapper.findAll();
        list.forEach(System.out::println);
    }
    @Test
    public void testFindById(){
        Teacher teacher = mapper.findById(3);
        System.out.println(teacher);
    }
    @Test
    public void testFindById2(){
        List<Teacher> list = mapper.findById2(2);
        list.forEach(System.out::println);
    }
}
