
import com.domain.User;
import com.mapper.UserMapper;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.Test;

import java.io.IOException;
import java.io.InputStream;
import java.util.List;

public class TestUserMapper {
    @Test
    public void findAllTest() throws IOException {
        // （1）读取核心配置文件
        InputStream is = Resources.getResourceAsStream("SqlMapConfig.xml");
        // （2）创建SqlSessionFactoryBuilder对象
        SqlSessionFactoryBuilder builder = new SqlSessionFactoryBuilder();
        // （3）SqlSessionFactoryBuilder对象获取SqlSessionFactory对象
        SqlSessionFactory factory = builder.build(is);
        // （4）SqlSessionFactory对象获取SqlSession对象
        SqlSession session = factory.openSession();
        // （5）SqlSession对象获取代理对象，可以直接操纵数据库
        UserMapper mapper = session. getMapper(UserMapper.class);
        // （6）代理对象执行方法
        List<User> list = mapper.findAll();
        list.forEach(System.out::println);
        // （7）释放资源
        session.close();
        is.close();
    }
    @Test
    public void testfindAll() throws IOException {
        // （1）读取核心配置文件
        InputStream is = Resources.getResourceAsStream("SqlMapConfig.xml");
        // （2）创建SqlSessionFactoryBuilder对象
        SqlSessionFactoryBuilder builder = new SqlSessionFactoryBuilder();
        // （3）SqlSessionFactoryBuilder对象获取SqlSessionFactory对象
        SqlSessionFactory factory = builder.build(is);
        // （4）SqlSessionFactory对象获取SqlSession对象
        SqlSession session = factory.openSession();
        // （5）SqlSession对象直接操纵数据库
        List<User> list = session.selectList("com.mapper.UserMapper.findAll");
        list.forEach(System.out::println);
        // （7）释放资源
        session.close();
        is.close();
    }
    @Test
    public void testAdd() throws IOException {
        InputStream is=Resources.getResourceAsStream("SqlMapConfig.xml");
        SqlSessionFactoryBuilder builder=new SqlSessionFactoryBuilder();
        SqlSessionFactory factory = builder.build(is);
        SqlSession session = factory.openSession();
        UserMapper mapper = session.getMapper(UserMapper.class);
        User user=new User("西华程序员","男","成都");
        mapper.add(user);
        session.commit();
        session.close();
        is.close();
    }
}
