
import com.domain.User;
import com.domain.pageQuery;
import com.mapper.UserMapper;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class TestUserMapper2 {
    InputStream is=null;
    SqlSession session=null;
    UserMapper mapper=null;
    @Before
    public void before() throws IOException {
        // （1）读取核心配置文件
         is = Resources.getResourceAsStream("SqlMapConfig.xml");
        // （2）创建SqlSessionFactoryBuilder对象
        SqlSessionFactoryBuilder builder = new SqlSessionFactoryBuilder();
        // （3）SqlSessionFactoryBuilder对象获取SqlSessionFactory对象
        SqlSessionFactory factory = builder.build(is);
        // （4）SqlSessionFactory对象获取SqlSession对象
         session = factory.openSession();
        // （5）SqlSession对象获取代理对象，可以直接操纵数据库
        mapper = session. getMapper(UserMapper.class);
     }
    @After
    public void after() throws IOException {
        this.session.close();
        this.is.close();
     }
    @Test
    public void testUpdate(){
        User user=new User(7,"西华工程师","女","郫县");
        this.mapper.update(user);
        this.session.commit();
     }
     @Test
    public void testDelete(){
        mapper.delete(7);
        session.commit();
     }
     @Test
    public void testfindById(){
         User user = mapper.findById(5);
         System.out.println(user);
     }
     @Test
    public void testfinfByUsernameLike(){
        List<User> list=mapper.findByUsernameLike("尚学堂");
        list.forEach(System.out::println);
     }
     @Test
    public void testfindPage(){
         List<User> list=mapper.findPage(0,3);
         list.forEach(System.out::println);
     }
    @Test
    public void testfindPage1(){
        List<User> list=mapper.findPage1(3,3);
        list.forEach(System.out::println);
    }
    @Test
    public void testfindPage2(){
        pageQuery query = new pageQuery(3,3);
        List<User> list=mapper.findPage2(query);
        list.forEach(System.out::println);
    }
    @Test
    public void testfindPage3(){
        Map<String, Object> map = new HashMap<>();
        map.put("startIndex",0);
        map.put("pageSize",4);
        List<User> list=mapper.findPage3(map);
        list.forEach(System.out::println);
    }
    @Test
    public void testfindCount(){
        int count=mapper.findCount();
        System.out.println(count);
    }
    @Test
    public void testAdd2(){
        User user=new User("西华程序猿","男","成都");
        System.out.println(user);
        mapper.add2(user);
        session.commit();
        System.out.println(user);
    }
}
