import com.domain.User;
import com.mapper.UserMapper2;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class TestUserMapper3 {
    InputStream is=null;
    SqlSession session=null;
    UserMapper2 mapper=null;
    @Before
    public void before() throws IOException {
        // （1）读取核心配置文件
        is = Resources.getResourceAsStream("SqlMapConfig.xml");
        // （2）创建SqlSessionFactoryBuilder对象
        SqlSessionFactoryBuilder builder = new SqlSessionFactoryBuilder();
        // （3）SqlSessionFactoryBuilder对象获取SqlSessionFactory对象
        SqlSessionFactory factory = builder.build(is);
        // （4）SqlSessionFactory对象获取SqlSession对象
        session = factory.openSession();
        // （5）SqlSession对象获取代理对象，可以直接操纵数据库
        mapper = session. getMapper(UserMapper2.class);
    }
    @After
    public void after() throws IOException {
        this.session.close();
        this.is.close();
    }
    @Test
    public void testFindByCondition(){
        User user=new User();
        user.setUsername("尚学堂");
        List<User> list = mapper.findByCondition(user);
        list.forEach(System.out::println);
    }
    @Test
    public void testUpdateUser(){
        User user=new User();
        user.setId(7);
        user.setAddress("郫县");
        mapper.updateUser(user);
        session.commit();
    }
    @Test
    public void testFindByUserName(){
        List<User> list = mapper.findByUserName("北京");
        list.forEach(System.out::println);
    }
    @Test
    public void testDeleteBatch(){
        int a[]={9,5};
        mapper.deleteBatch(a);
        session.commit();
    }
    @Test
    public void testInsertBatch(){
        User user1 = new User("西华运动员","女","郫都");
        User user2= new User("西华建筑师","女","郫都");
        List<User> list = new ArrayList<>();
        list.add(user1);
        list.add(user2);
        mapper.insertBatch(list);
        session.commit();
    }
    @Test
    public void testFindUser(){
        Map<String,Object> map=new HashMap<>();
        map.put("sex","男");
        map.put("address","北京");
        List<User> list = mapper.findUser(map);
        list.forEach(System.out::println);
        session.commit();
    }
}
