import com.domain.User;
import com.mapper.UserMapper;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.Before;
import org.junit.Test;

import java.io.IOException;
import java.io.InputStream;

public class TestUserMapper4 {
    @Test
    public void testCache1() throws IOException {
        InputStream is = Resources.getResourceAsStream("SqlMapConfig.xml");
        SqlSessionFactoryBuilder builder=new SqlSessionFactoryBuilder();
        SqlSessionFactory factory = builder.build(is);
        SqlSession session = factory.openSession();
        UserMapper mapper1 = session.getMapper(UserMapper.class);
        UserMapper mapper2 = session.getMapper(UserMapper.class);
        User user1 = mapper1.findById(1);
        System.out.println(user1);
        System.out.println(user1.hashCode());
        System.out.println("-------------------------------------");
       // session.close();如果关闭SqlSession对象，则后面再调用这个对象会报错。因为对象不可用了，所以缓存也不能用了  第一种清空缓存方式
        User user2 = mapper2.findById(1);//直接从缓存中获取，没有执行sql语句
        System.out.println(user2);
        System.out.println(user2.hashCode());
    }
    @Test
    public void TestCache1() throws IOException {
        InputStream is = Resources.getResourceAsStream("SqlMapConfig.xml");
        SqlSessionFactoryBuilder builder=new SqlSessionFactoryBuilder();
        SqlSessionFactory factory = builder.build(is);
        SqlSession session = factory.openSession();
        UserMapper mapper1 = session.getMapper(UserMapper.class);
        UserMapper mapper2 = session.getMapper(UserMapper.class);
        User user1 = mapper1.findById(1);
        System.out.println(user1);
        System.out.println(user1.hashCode());
        System.out.println("-------------------------------------");
        // session.close();如果关闭SqlSession对象，则后面再调用这个对象会报错。因为对象不可用了，所以缓存也不能用了
        session.clearCache();//跟上面对比只多了这一行代码，所以需要重新调用sql语句 第二种清空缓存方式
        //session.commit();//一级缓存一般只存活在一次事务中，所以当事务提交以后，缓存一样会被清空 第三种清空缓存方式
        //SqlSession对象在调用增删改操作后，缓存一样被清空 第四种清空缓存方式
        User user2 = mapper2.findById(1);//直接从缓存中获取，没有执行sql语句
        System.out.println(user2);
        System.out.println(user2.hashCode());
    }
    @Test
    public void testCache2() throws IOException {
        InputStream is = Resources.getResourceAsStream("SqlMapConfig.xml");
        SqlSessionFactoryBuilder builder=new SqlSessionFactoryBuilder();
        SqlSessionFactory factory = builder.build(is);
        SqlSession session1 = factory.openSession();
        SqlSession session2 = factory.openSession();
        UserMapper mapper1 = session1.getMapper(UserMapper.class);
        UserMapper mapper2 = session2.getMapper(UserMapper.class);
        User user1 = mapper1.findById(1);
        System.out.println(user1);
        System.out.println(user1.hashCode());
        System.out.println("-------------------------------------");
        User user2 = mapper2.findById(1);//这是两个SqlSession对象，都要执行sql语句
        System.out.println(user2);
        System.out.println(user2.hashCode());
    }
    @Test
    public void testCache3() throws IOException {
        InputStream is = Resources.getResourceAsStream("SqlMapConfig.xml");
        SqlSessionFactoryBuilder builder=new SqlSessionFactoryBuilder();
        SqlSessionFactory factory = builder.build(is);
        SqlSession session1 = factory.openSession();
        SqlSession session2 = factory.openSession();
        UserMapper mapper1 = session1.getMapper(UserMapper.class);
        UserMapper mapper2 = session2.getMapper(UserMapper.class);
        User user1 = mapper1.findById(1);
        System.out.println(user1);
        System.out.println(user1.hashCode());
        session1.close();//让一级缓存失效，才能拿到二级缓存
        System.out.println("-------------------------------------");
        User user2 = mapper2.findById(1);//这是两个SqlSession对象，都要执行sql语句
        System.out.println(user2);
        System.out.println(user2.hashCode());
    }
}
